<template>
    <div class="wrapper">
        <md-toolbar class="md-dense md-red toolbar-heigth">
            <h3 class="ml-8  md-title text-align-left text-white">
                <md-icon class="text-white">list</md-icon>
                RECURSOS
            </h3>
        </md-toolbar>
        <div class="md-layout md-alignment-top-center">
            <div class="md-layout-item md-size-70 md-small-size-100">
                <md-card>
                    <md-card-area>
                        <!-- <md-card-header>
                        Listado de colecciones
                    </md-card-header> -->
                        <md-card-content class="mt-3">
                            <!-- <div class="md-layout"> -->
                            <div class="md-layout-item">
                                <h3>Listado de recursos</h3>
                            </div>
                            <!-- </div> -->

                            <div v-if="searched && searched.length > 0">
                                <div class="md-layout-item">
                                    <md-table v-model="searched" md-sort="id" md-sort-order="desc" md-card md-fixed-header>
                                        <md-table-toolbar>
                                            <div class="md-layout">
                                                <!-- <div class="md-layout-item">
                                                    <md-button
                                                        class="md-dense md-raised md-primary"
                                                        >Excel</md-button
                                                    >
                                                    <md-button
                                                        class="md-dense md-raised md-primary"
                                                        >PDF</md-button
                                                    >
                                                </div> -->
                                                <div class="md-layout-item">
                                                    <md-field>
                                                        <md-input
                                                            @input="searchOnTable"
                                                            v-model="search"
                                                            placeholder="Busca un titulo"
                                                            required
                                                        ></md-input>
                                                        <span class="md-error">Ingrese un título</span>
                                                    </md-field>
                                                </div>
                                            </div>
                                            <!-- <h1 class="md-title">Colecciones</h1> -->
                                        </md-table-toolbar>

                                        <md-table-row slot="md-table-row" slot-scope="{ item }">
                                            <md-table-cell md-label="Título" md-sort-by="label">{{ item.title }}</md-table-cell>
                                            <md-table-cell md-label="Categorías">{{
                                                item.categories ? item.categories.map((m) => m.label).join(', ') : ''
                                            }}</md-table-cell>
                                            <md-table-cell md-label="Autor">{{ user.username }}</md-table-cell>
                                            <md-table-cell md-label="Accciones">
                                                <md-button
                                                    :to="{
                                                        name: 'resourcedetail',
                                                        params: { id: item.id }
                                                    }"
                                                >
                                                    <md-icon>remove_red_eye</md-icon>
                                                    <span>Ver</span>
                                                </md-button>
                                                <md-button
                                                    :to="{
                                                        name: 'resource',
                                                        params: { id: item.id }
                                                    }"
                                                >
                                                    <md-icon>create</md-icon>
                                                    <span>Editar</span>
                                                </md-button>
                                            </md-table-cell>
                                        </md-table-row>
                                    </md-table>
                                </div>
                            </div>
                        </md-card-content>
                    </md-card-area>
                </md-card>
            </div>
        </div>
        <!-- <div class="container">
            <div class="md-layout md-alignment-top-center">
                <div class="md-layout-item md-size-50 md-small-size-100">
                    <card-recurso
                        v-for="resource in resources"
                        v-bind:key="resource.id"
                        :resource="resource"
                    >
                        <template slot="button">
                            <star-rating
                                inactive-color="#4A6274"
                                active-color="#59A8BA"
                                @rating-selected="sendVote(resource)"
                                :star-size="starSize"
                                :show-rating="showRating"
                                v-model="resource.strarValue"
                            ></star-rating>
                        </template>

                        <template slot="pdf">
                            <pdf-recurso :resource="resource"></pdf-recurso>
                        </template>

                        <template slot="video">
                            <video-recurso :resource="resource"></video-recurso>
                        </template>
                    </card-recurso>
                </div>
            </div>
        </div> -->
    </div>
</template>

<script>
const toLower = (text) => {
    return text.toString().toLowerCase();
};

const searchByName = (items, term) => {
    if (term) {
        return items.filter((item) => toLower(item.title).includes(toLower(term)));
    }

    return items;
};

import axios from 'axios';
export default {
    name: 'in-resources',
    data() {
        return {
            img: require('../../../assets/img/bg2.jpg'),
            endPoint: '/api/resource',
            searched: [],
            resources: [],
            showRating: false,
            starSize: 20,
            endPointVote: '/api/sendVote',
            search: null
        };
    },
    computed: {
        user() {
            return this.$auth.watch.data;
        }
    },
    methods: {
        // myvote(id) {
        //     this.resources.forEach((element, index, array) => {
        //         if(element.ratings.length > 0){
        //             let vote = element.ratings.find(c => c.user_id == id);
        //             this.resources[index].strarValue = vote.total_rating;
        //         }
        //     });
        // },
        // sendVote(resource) {
        //     if (this.user == null) {
        //         this.$root.WarnMgs("Es necesario iniciar sesión para votar");
        //     } else {
        //         let vote = {
        //             resource_id: resource.id,
        //             rating: resource.strarValue
        //         };
        //         axios
        //             .post(this.endPointVote, vote)
        //             .then(response => {
        //                 if (response && response.data) {
        //                     this.getResources();
        //                     this.$root.SuccessMgs(response.data.message);
        //                 }
        //             })
        //             .catch(error => {
        //                 console.log("Error en sendVote" + error);
        //                 this.$root.ErrorMgs("Error a registrar el voto");
        //             });
        //     }
        // },
        searchOnTable() {
            // debugger
            this.searched = searchByName(this.resources, this.search);
        },
        getResources() {
            axios
                .get(this.endPoint)
                .then((res) => {
                    if (res && res.data) {
                        this.resources = res.data.data;
                        this.searched = this.resources;
                        // if (this.user != null) {
                        //     this.myvote(this.user.id);
                        // }
                    } else {
                        this.resources = [];
                    }
                })
                .catch((error) => {
                    console.log('Error getResources' + error);
                });
        }
    },
    mounted() {
        this.getResources();
    }
};
</script>

<style lang="scss" scoped>
.social-icon {
    text-align: center;
    padding: 8px;
}
</style>
